#include <amxmodx>
#include <sqlx>
#include <colorchat>

new Handle:info, gszQuery[768];
new sid[33][35], ip[33][16], nick_gracza[33][128];
new czas_gracza[33];
new mapa[64], czas[2][11];
native kobieta(id);

public plugin_init() {
	register_plugin("JB Top czasu online", "1.0", "Deva");

	register_clcmd("say /czas", "PokazCzas");
}

public plugin_natives() {
	register_native("pobierz_czasgry", "pobierzczas", 1);
	register_native("pobierz_topkeczasu", "pobierztopczasu", 1);
	register_native("pobierz_rankczasu", "pobierzrankczasu", 1);
}

public pobierzczas(id)
{
return czas_gracza[id] + get_user_time(id, 1);
}

public plugin_cfg() {
	get_mapname(mapa, 63);
	info = SQL_MakeDbTuple("sql.pukawka.pl", "505605", "24exqe", "505605_czas");

	new error, szError[128];
	new Handle:hConn = SQL_Connect(info, error, szError, 127);
	if(error) {
		log_amx("Blad: %s", szError);
		return;
	}
	new Handle: query = SQL_PrepareQuery(hConn, "CREATE TABLE IF NOT EXISTS `topka` (\
		`id` int(11) NOT NULL AUTO_INCREMENT,\
		`Nick` varchar(32) NOT NULL,\
		`SteamID` varchar(35) NOT NULL,\
		`IP` varchar(16) NOT NULL,\
		`Czas` int(10) NOT NULL,\
		PRIMARY KEY (`id`)\
	)");
	SQL_Execute(query)
	SQL_FreeHandle(query);
	SQL_FreeHandle(hConn);
}

public plugin_end() SQL_FreeHandle(info);

public PokazCzas(id) {
	new czas = pobierzczas(id);
	new d = czas / 86400;
	new h = czas % 86400 / 3600;
	new m = czas % 3600 / 60;

	ColorChat(id, GREEN, "^4[JailBreak]^1 %s na serwerze^3 %i^1 d%s,^3 %i^1 godzin%s^3 %i^1 minut%s", kobieta(id) ? "Spędziłaś" : "Spędziłeś", d, d == 1 ? "zien" : "ni", h, h == 1 ? "e" : (1 < h < 5) ? "y," : ",", m, m == 1 ? "e" : (1 < m < 5) ? "y" : "");
	return 1;
}

public pobierzrankczasu(id)
{
	new data[2];
	data[0] = id;
	data[1] = get_user_userid(id);

	SQL_FormatQuery("SELECT COUNT(*) FROM `topka` WHERE `Czas` >= %i", pobierzczas(id));
	SQL_ThreadQuery(info, "PobierzRank", gszQuery, data, 2);
}

public pobierztopczasu(id)
{
	new data[2];	
	
	data[0] = id;
	data[1] = get_user_userid(id);
	
	formatex(gszQuery, 255, "SELECT * FROM `topka` ORDER BY `Czas` DESC LIMIT 15");
	SQL_ThreadQuery(info, "PobierzTop", gszQuery, data, 2);
}

public PobierzTop(failstate, Handle:query, error[], errnum, data[], size) {
	if(failstate != 0) {
		log_amx("<Zapytanie> Blad: %s", error);
		return;
	}
	new id = data[0];
	if(!is_user_connected(id) && !is_user_connecting(id)) return;
	if(!SQL_NumRows(query)) return;

	new buffer[2048], szName[41], iLen, i;
	iLen = formatex(buffer[iLen], 2047-iLen, "<head><style>table{border-collapse:collapse;background-color:#3D5450}td{border:0.2em solid #2F413E;text-align:center;height:1.2em;font-size: 0.8em}body{background-image:url(http://w43.1shot1kill.pl/FD/srv62854/cstrike/models/zasady_jb/tlo.png);background-size:auto;color:#DADADA;}</style></head><body><br><br><center><table width=80%%><tr style=^"background-color:#2F413E;^"><td>#. Gracz<td>Czas online");

	if(SQL_NumRows(query)) {
		while(SQL_MoreResults(query)) {
			i ++;
			SQL_ReadResult(query, SQL_FieldNameToNum(query, "Nick"), szName, 40);
			replace_all(szName, 40, "<", "&lt;");
			replace_all(szName, 40, ">", "&gt;");

			new czas = SQL_ReadResult(query, SQL_FieldNameToNum(query, "Czas"));
			
			switch(i) {
				case 1: {
					iLen += formatex(buffer[iLen], 2047-iLen, "<tr style=^"color: #D9D919;^"><td>%d. %s<td>%i d %i h %i m", i, szName, czas / 86400, czas % 86400 / 3600, czas % 3600 / 60);
				}
				
				case 2: {
					iLen += formatex(buffer[iLen], 2047-iLen, "<tr style=^"color: #8A8A8A;^"><td>%d. %s<td>%i d %i h %i m", i, szName, czas / 86400, czas % 86400 / 3600, czas % 3600 / 60);
				}
				
				case 3: {
					iLen += formatex(buffer[iLen], 2047-iLen, "<tr style=^"color: #BC8362;^"><td>%d. %s<td>%i d %i h %i m", i, szName, czas / 86400, czas % 86400 / 3600, czas % 3600 / 60);
				}
				
				default: {
					iLen += formatex(buffer[iLen], 2047-iLen, "<tr><td>%d. %s<td>%i d %i h %i m", i, szName, czas / 86400, czas % 86400 / 3600, czas % 3600 / 60);
				}
			}
			
			SQL_NextRow(query);
		}
		
	}

	iLen += copy(buffer[iLen], 2047-iLen, "</table></body>");
	show_motd(id, buffer, "Top 15")
}

public PobierzRank(failstate, Handle:query, error[], errnum, data[], size) {
	if(failstate != 0) {
		log_amx("<Zapytanie> Blad: %s", error);
		return;
	}
	new id = data[0];
	if(!is_user_connected(id) && !is_user_connecting(id)) return;

	new czas = pobierzczas(id);
	new d = czas / 86400;
	new h = czas % 86400 / 3600;
	new m = czas % 3600 / 60;

		ColorChat(id, GREEN, "*^1W rankingu czasu online zajmujesz pozycję^3 %i^1 mając^3 %i^1 d%s,^3 %i^1 godzin%s^3 %i^1 minut%s", SQL_ReadResult(query, 0)+1, d, d == 1 ? "zien" : "ni", h, h == 1 ? "e" : (1 < h < 5) ? "y," : ",", m, m == 1 ? "e" : (1 < m < 5) ? "y" : "");
}

public client_connect(id) {
	if(is_user_hltv(id)) return;

	get_user_name(id, nick_gracza[id], 127);
	get_user_authid(id, sid[id], 34);
	get_user_ip(id, ip[id], 15, 1);

	replace_all(nick_gracza[id], 127, "\\", "\\\\");
	replace_all(nick_gracza[id], 127, "\0", "\\0");
	replace_all(nick_gracza[id], 127, "\n", "\\n");
	replace_all(nick_gracza[id], 127, "\r", "\\r");
	replace_all(nick_gracza[id], 127, "\x1a", "\Z");
	replace_all(nick_gracza[id], 127, "'", "\'");
	replace_all(nick_gracza[id], 127, "^"", "\^"");
	replace_all(nick_gracza[id], 127, "`", "\`");
	replace_all(nick_gracza[id], 127, "%", "\%");

	czas_gracza[id] = 0;

	static data[1]; data[0] = id;
	SQL_FormatQuery("SELECT * FROM `topka` WHERE `Nick` = '%s'", nick_gracza[id]);
	SQL_ThreadQuery(info, "PobierzDane", gszQuery, data, 1);
}

public client_infochanged(id) {
	if(!is_user_connected(id)) return;
	if(is_user_hltv(id)) return;

	new name[128]; get_user_info(id, "name", name, 127);
	if(equal(name, nick_gracza[id])) return;

	replace_all(name, 127, "\\", "\\\\");
	replace_all(name, 127, "\0", "\\0");
	replace_all(name, 127, "\n", "\\n");
	replace_all(name, 127, "\r", "\\r");
	replace_all(name, 127, "\x1a", "\Z");
	replace_all(name, 127, "'", "\'");
	replace_all(name, 127, "^"", "\^"");
	replace_all(name, 127, "`", "\`");
	replace_all(name, 127, "%", "\%");
	formatex(nick_gracza[id], 127, name);
}

public PobierzDane(failstate, Handle:query, error[], errnum, data[], size) {
	if(failstate != 0) {
		log_amx("<Zapytanie> Blad: %s", error);
		return;
	}
	new id = data[0];

	if(!is_user_connected(id) && !is_user_connecting(id)) return;
	if(SQL_NumRows(query)) {
		czas_gracza[id] += get_user_time(id, 1) + SQL_ReadResult(query, SQL_FieldNameToNum(query, "Czas"));
	} else {
		SQL_FormatQuery("INSERT INTO `topka` (`Nick`, `SteamID`, `IP`, `Czas`) VALUES ('%s', '%s', '%s', %i)", nick_gracza[id], sid[id], ip[id], get_user_time(id, 1));
		SQL_ThreadQuery(info, "ZapiszDane", gszQuery);
	}
	get_time("%d.%m.%Y", czas[0], 10);
	get_time("%H:%M", czas[1], 5);
}

public client_disconnect(id) {
	if(is_user_hltv(id)) return;

	SQL_FormatQuery("UPDATE `topka` SET `Czas` = `Czas` + %i WHERE `Nick` = '%s'", get_user_time(id, 1), nick_gracza[id]);
	SQL_ThreadQuery(info, "ZapiszDane", gszQuery);
}

public ZapiszDane(failstate, Handle:query, error[], errnum, data[], size) {
	if(failstate != 0) {
		log_amx("<Zapytanie> Blad: %s", error);
		return;
	}
}

stock SQL_FormatQuery(szQuery[], ...) vformat(gszQuery, 767, szQuery, 2);
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1033\\ f0\\ fs16 \n\\ par }
*/
